From 2d6f1223dec62a8d2563ac2d5db8d208a9a7819f Mon Sep 17 00:00:00 2001
From: bings <bings@codeaurora.org>
Date: Sun, 12 Apr 2020 15:35:57 +0800
Subject: [PATCH 53/63] cfg80211: Use new wiphy flag WIPHY_FLAG_DFS_OFFLOAD

When flag WIPHY_FLAG_DFS_OFFLOAD is defined, the driver would handle
all the DFS related operations. Therefore the kernel needs to ignore
the DFS state that it uses to block the userspace calls to the driver
through cfg80211 APIs. Also it should treat the userspace calls to
start radar detection as a no-op

Signed-off-by: Kang Xu <kangxu@codeaurora.org>
---
 include/net/cfg80211.h | 2 ++
 net/wireless/chan.c    | 6 ++++--
 net/wireless/nl80211.c | 3 +++
 3 files changed, 9 insertions(+), 2 deletions(-)

diff --git a/include/net/cfg80211.h b/include/net/cfg80211.h
index 70e48f66dac8..3af2e8bb27e7 100644
--- a/include/net/cfg80211.h
+++ b/include/net/cfg80211.h
@@ -4112,6 +4112,7 @@ struct cfg80211_ops {
  *	beaconing mode (AP, IBSS, Mesh, ...).
  * @WIPHY_FLAG_HAS_STATIC_WEP: The device supports static WEP key installation
  *	before connection.
+ *  @WIPHY_FLAG_DFS_OFFLOAD: The driver handles all the DFS related operations.
  */
 enum wiphy_flags {
 	/* use hole at 0 */
@@ -4138,6 +4139,7 @@ enum wiphy_flags {
 	WIPHY_FLAG_SUPPORTS_5_10_MHZ		= BIT(22),
 	WIPHY_FLAG_HAS_CHANNEL_SWITCH		= BIT(23),
 	WIPHY_FLAG_HAS_STATIC_WEP		= BIT(24),
+	WIPHY_FLAG_DFS_OFFLOAD			= BIT(25),
 };
 
 /**
diff --git a/net/wireless/chan.c b/net/wireless/chan.c
index fcac5c6366e1..8d85179b9cd7 100644
--- a/net/wireless/chan.c
+++ b/net/wireless/chan.c
@@ -422,7 +422,8 @@ static int cfg80211_get_chans_dfs_required(struct wiphy *wiphy,
 		if (!c)
 			return -EINVAL;
 
-		if (c->flags & IEEE80211_CHAN_RADAR)
+		if ((c->flags & IEEE80211_CHAN_RADAR) &&
+		    !(wiphy->flags & WIPHY_FLAG_DFS_OFFLOAD))
 			return 1;
 	}
 	return 0;
@@ -702,7 +703,8 @@ static bool cfg80211_get_chans_dfs_available(struct wiphy *wiphy,
 		if (c->flags & IEEE80211_CHAN_DISABLED)
 			return false;
 
-		if ((c->flags & IEEE80211_CHAN_RADAR) &&
+		if (!(wiphy->flags & WIPHY_FLAG_DFS_OFFLOAD) &&
+		    (c->flags & IEEE80211_CHAN_RADAR)  &&
 		    (c->dfs_state != NL80211_DFS_AVAILABLE) &&
 		    !(c->dfs_state == NL80211_DFS_USABLE && dfs_offload))
 			return false;
diff --git a/net/wireless/nl80211.c b/net/wireless/nl80211.c
index 692bcd35f809..f144530b8dc8 100644
--- a/net/wireless/nl80211.c
+++ b/net/wireless/nl80211.c
@@ -8570,6 +8570,9 @@ static int nl80211_start_radar_detection(struct sk_buff *skb,
 	if (err)
 		return err;
 
+	if (rdev->wiphy.flags & WIPHY_FLAG_DFS_OFFLOAD)
+		return -EOPNOTSUPP;
+
 	if (netif_carrier_ok(dev))
 		return -EBUSY;
 
-- 
2.17.1

